/*
************************************************************************
		an example of LKI implementation

************************************************************************
*/



class TTestLKI : public TKernelInfo
{
public:
	TGen *best;	//an copy of locally best gene

	TTestLKI(TGen& bg);	//constructor
	virtual ~TTestLKI();	//destructor

	//serialization methods
	TTestLKI(BYTE** rawbytes,uint len,BOOL subclass=FALSE);		//see TObj
	virtual uint GetSerSize(BOOL subclass=FALSE); 			//see TObj
	virtual uint Serialize(BYTE **rawbytes,BOOL subclass=FALSE);	//see TObj
};

TTestLKI::TTestLKI(TGen& bg) : TKernelInfo(KIL_TEST) 
{ 
	best = new TGen(0);
	(*best) = bg;		//assign 
}

TTestLKI::~TTestLKI()
{
	delete best;
}

uint TTestLKI::GetSerSize(BOOL subclass)
{
	uint sum = 0;
	
	//call predecestor
	sum += TKernelInfo::GetSerSize(subclass);

	sum += best->GetSerSize();

	return sum;
}

uint TTestLKI::Serialize(BYTE **rawbytes,BOOL subclass)
{
	uint sum = 0;

	//call predecestor
	sum += TKernelInfo::Serialize(rawbytes,subclass);	
	sum += best->Serialize(rawbytes,subclass);
	
	return sum;
}

TTestLKI::TTestLKI(BYTE** rawbytes,uint len,BOOL subclass)
 : TKernelInfo(rawbytes,len,subclass)		//call predecestor
{
	best = new TGen(rawbytes,len,subclass);
}
