Example of de/serialisation methods

class MyClass : TObj
{
  int attribute;            // a scalar type attribute
  char *string;           // an array attribute

  SubClass *sub;      // a subclass
}

uint MyClass::GetSerSize(BOOL subclass)
{
 uint sum = 0;

 //call predecessor
 sum += TObj::GetSerSize(subclass);

 //add length of the encoded attribute
 sum += GetSerSizeInt(attribute);    

 //add length of the encoded length of array
 sum += GetSerSizeInt(strlen(string)+1);    

 //add length of the encoded array
 sum += GetSerSizeChar(string,strlen(string)+1);   

 //add length of the subclass
 if(subclass) sum += sub->GetSerSize(subclass); 

 return sum;
}

uint MyClass::Serialize(BYTE** rawbytes,BOOL subclass)
{
 uint sum = 0;

 //call predecessor
 sum += TObj::Serialize(rawbytes,subclass);

 //serialise attribute
 sum += SerializeInt(attribute,rawbytes);    

 //serialise the length of array
 sum += SerializeInt(strlen(string)+1,rawbytes);    

 //serialise array
 sum += SerializeChar(string,strlen(string)+1,rawbytes);   

 //serialise the subclass
 if(subclass) sum += sub->Serialize(rawbytes,subclass); 

 return sum;
}

MyClass::MyClass(BYTE** rawbytes,uint len,BOOL subclass)
 : TObj(rawbytes,subclass)    //call predecessor
{
 int len;

 //deserialise attribute
 attribute = DeserializeInt(rawbytes);

 //deserialise the length of array
 len = DeserializeInt(rawbytes);

 //allocate array
 array = (char*) malloc(len*sizeof(char));

 //deserialise array
 DeserializeChar(array,len,rawbytes);
}

